import math
conversion_efficiency=1*(10**-6)

def get_spectrum(file):  #takes a two column, comma separated txt file and creates a list of two components elements--[wavelength(nm), relative intensity (linear)]
    initial_spectrum=list()
    file=open(file)
    while True:
        try:
            component=file.readline().split(',')
            num_component=[float(component[0]),float(component[1])]
            initial_spectrum.append(num_component)
        except:
            break
    return(initial_spectrum)
            
      
def down_shift(wavelength): #wavelength (nm), outputs new wavelength shifted by +89.6 THz
    freq=2.998*(10**(17))/(wavelength)
    freq_shifted=freq+89.6*(10**12)
    wavelength_shifted=(2.998*(10**17))/(freq_shifted)
    return wavelength_shifted

def up_shift(wavelength):
    freq=2.998*(10**(17))/(wavelength)
    freq_shifted=freq-89.6*(10**12)
    wavelength_shifted=(2.998*(10**17))/(freq_shifted)
    return wavelength_shifted


def spectral_broadening(file, data='linear'):   #shifts each component of the initial spectrum up and down by 89.6 THz according to the given conversion efficiency.  Intensities in the initial spectrum should be linear#
    final_spectrum=list()
    initial_spectrum=get_spectrum(file)
    if data=='linear':
        for i in range(len(initial_spectrum)):
            final_spectrum.append([initial_spectrum[i][0],initial_spectrum[i][1]*(1-2*conversion_efficiency)])
            final_spectrum.append([down_shift(initial_spectrum[i][0]),initial_spectrum[i][1]*conversion_efficiency])
            final_spectrum.append([up_shift(initial_spectrum[i][0]),initial_spectrum[i][1]*conversion_efficiency])
    if data=='log':
        for i in range(len(initial_spectrum)):
            final_spectrum.append([initial_spectrum[i][0],30+10*math.log10(10**((initial_spectrum[i][1]-30)/10)*(1-2*conversion_efficiency))])
            final_spectrum.append([down_shift(initial_spectrum[i][0]),30+10*math.log10(10**((initial_spectrum[i][1]-30)/10)*(conversion_efficiency))])
            final_spectrum.append([up_shift(initial_spectrum[i][0]),30+10*math.log10(10**((initial_spectrum[i][1]-30)/10)*(conversion_efficiency))])
        
    output=open('%s_modulated.txt' % str(file)[:-4],'w')
    for element in final_spectrum:
        output.write(str(element[0]))
        output.write(',')
        output.write(str(element[1]))
        output.write('\n')
    output.close()

    
